from hashFunction import *
from OrderedList import *

class HashTable:
   def __init__(self,size):
      self.slots = [None] * size
      self.itemCount = 0
      self.size = size
      for i in range(size):
         self.slots[i] = OrderedList()

   def hashfunction(self,item,size):
      "Calls Professor Fienup's original hashfunction"
      return hashString(item,size)

   def hashfunctionA(self,item,size):
      return len(item) % self.size

   def hashfunctionB(self,item,size):
      sum = 0
      for pos in range(len(item)):
          sum = sum + ord(item[pos])
      return sum%size

   def hashfunctionC(self,astring,size):
        "Takes a piece of data from all letters of a word"
        num=0
        for pos in range(len(astring)):
            num+=ord(astring[pos]) #add all letter numbers
        #end for
        num=str(num**2)            #square sum
        cut=len(num)/4             #find cutoff range
        newnum=''                  #initialize new string
        for i in range(cut,len(num)-cut):
            newnum+=num[i]         #get new number b/t cutoff range
        #end for
        return int(newnum)%size
    #end def


   def hashfunctionD(self, item, temp):
        """Determines what slot to put the key / value"""

        item = item.lower()
        number = ""
            
        for x in range(len(item)):
            number += str(ord(item[x]))
        # end for

        number = str((int(number)*int(number)))
        middle = len(number)/2
        number = int(number[middle-1] + number[middle] + number[middle+1])

        return number%self.size

    # END hashFunction()

   def hashfunctionE(self,item,size):
        "Determines the location where the item is stored based on the individual char values \
         and their position in the string."
        
        value=0

        for i in range(len(item)):
            value=value+ord(item[i])*i

        return value%self.size

   def hashfunctionF(self, item, size):
        """Computes the hash used for storing data"""
        # This function is modified to store ordinal numbers as a string,
        # concatenate them, turn the string back into an int, and use that
        # in the hash function
        if type(item) is str:
            total = ''
            pos = 1
            for letter in item:
                total += str(ord(letter) * (pos * 3))
                pos += 1
            # end for loop
            item = int(total)
        return item % size
    # end hashfunction method


   def store(self,item,data):
      hashvalue = self.hashfunction(item,len(self.slots))
      self.itemCount += 1
      self.slots[hashvalue].add(item, data)

   def length(self):
      return self.itemCount

   def search(self,item):
      hashvalue = self.hashfunction(item,len(self.slots))
      return self.slots[hashvalue].search(item)
   
   # overloading __getitem__ and __setitem__ allows for access using [] as
   # myHashTable[33] = 'cat'
   # myHashTable[33]
   def __getitem__(self,item):
      return self.search(item)

   def __setitem__(self,item,data):
      self.store(item,data)

   def show(self):
      for i in range(self.size):
         print "Slot", i, ":",
         self.slots[i].show()
         print

   def showStats(self):
      maxSlotSize = self.slots[0].length()
      for i in range(1,self.size):
         if maxSlotSize < self.slots[i].length():
            maxSlotSize = self.slots[i].length()
      print "Hash Table Size = %d, Number of items in the Hash Table = %d" % (self.size, self.itemCount)
      print "Slot Size: Maximum = %d   Average = %.2f" % (maxSlotSize, float(self.itemCount)/self.size)

         
   
