from queueClass import *
from HashTable import *
from time import clock
import re
import cProfile

def wordConcordance():
    start = clock()
    parser = re.compile('[a-z]+([-][a-z]+)*([\'][a-z]+)?', re.IGNORECASE)
    nonwhiteSpaceParser = re.compile('\S')   # matches any non-whitespace character

    stopWordSize = 60
    concordanceSize = 40
#    stopWordSize = 6000
#    concordanceSize = 400
    concordanceFile = open("concordanceFile.txt",'w')
    stopWordsFile = open("stop_words.txt", 'r')
    textFile = open("hw4data.txt", 'r')
    stopWordDictionary = HashTable(stopWordSize)
    for line in stopWordsFile:
        if nonwhiteSpaceParser.search(line):
            wordIter = parser.finditer(line)
            for reMatchObject in wordIter:
                word = reMatchObject.group()
                if stopWordDictionary.search(word) == None:
                    stopWordDictionary[word] = []

    wordDictionary = HashTable(concordanceSize)
    lineNumber = 0
    concordanceWords = []
    for line in textFile:
        if nonwhiteSpaceParser.search(line):
            lineNumber += 1
            wordIter = parser.finditer(line.lower())
            for reMatchObject in wordIter:
                word = reMatchObject.group()
                if stopWordDictionary.search(word) == None:
                    data = wordDictionary.search(word)
                    if data != None:
                        data.enqueue(lineNumber)
                    else:
                        lineQueue = Queue()
                        lineQueue.enqueue(lineNumber)
                        wordDictionary[word] = lineQueue
                        concordanceWords.append(word)

    print "Stop Words Hash Table Stats: "
    stopWordDictionary.showStats()                
    print "Concordance Words Hash Table Stats: "
    wordDictionary.showStats()                

    concordanceWords.sort()
    for word in concordanceWords:
        concordanceFile.write(word)
        lineQueue = wordDictionary[word]
        while not lineQueue.isEmpty():
            concordanceFile.write(" "+str(lineQueue.dequeue()))
        concordanceFile.write("\n")

    concordanceFile.close()
    end = clock()
    runTime = end - start
    print "Word concordance HW#4 using HashTables of size:  stopWords %d and " \
          "concordance %d is %.6f (sec)" % (stopWordSize, concordanceSize, runTime)
    print "\n***************** cProfile Output Below ***********************\n"
cProfile.run('wordConcordance()')                        
