# queueClass.py

from nodeClass import *

class Queue:
    def __init__(self):
        self.front = None
        self.rear = None
        self.itemCount = 0

    def isEmpty(self):
        return self.itemCount == 0

    def enqueue(self, item):
        newNode = Node(item)
        if self.itemCount == 0:
            self.front = newNode
        else:
            self.rear.setNext(newNode)
        self.rear = newNode
        self.itemCount = self.itemCount + 1
        
    def dequeue(self):
        frontItem = self.front.getData()
        self.front = self.front.getNext()
        self.itemCount = self.itemCount - 1
        if self.itemCount == 0:
            self.rear = None
        return frontItem

    def show(self):
        ptr = self.front
        print "Queue from Front to Rear:",
        while ptr != None:
            print str(ptr.getData()),
            ptr = ptr.getNext()
        print

    def peek(self):
        if self.front:
            return self.front.getData()
        else:
            return None
    
    def size(self):
        return self.itemCount
